from pygame import display, image
from pygame.locals import *

from GameChild import *
from Input import *

class Display(GameChild):

    def __init__(self, game):
        GameChild.__init__(self, game)
        self.set_screen()
        self.set_caption()
        self.set_icon()
        self.subscribe_to(Input.command_event, self.toggle_fullscreen)

    def set_screen(self, flags=0):
        configuration = self.get_configuration()
        self.screen = display.set_mode(configuration["display-dimensions"], flags)

    def set_caption(self):
        display.set_caption(self.get_configuration()["game-title"])

    def set_icon(self):
        path = self.get_resource("display-icon-path")
        display.set_icon(image.load(path).convert_alpha())

    def get_screen(self):
        return self.screen

    def get_size(self):
        return self.screen.get_size()

    def toggle_fullscreen(self, event):
        if event.command == "fullscreen":
            screen = self.screen
            cpy = screen.convert()
            self.set_screen(self.screen.get_flags() ^ FULLSCREEN)
            screen.blit(cpy, (0, 0))
